searchNodes=[{"doc":"Litefs sets a primary file in the directory of the mount it is managing to indicate the location of the primary when on a replica. There is no file on the primary. Elixir communicates in a mesh with names that may be different than the hostname that is contained in the file managed by Litefs. As Litefs can change the primary without notice, we need to periodically update the state of the primary in memory. There are several cases when we try to update the primary: when a node goes connects / up / down after the primary_check_time has passed which is default 30 seconds NOTE 2022-08-24 On a litefs crash with a stale filesystem, there are some errors to handle. Elixir will have a stale filehandle and will return (Exqlite.Error) disk I/O error Litefs will not be able to unmount or restart as Elixir has the file handle open. Based on the fly_rpc and fly_postgres packages.","ref":"Litefs.html","title":"Litefs","type":"module"},{"doc":"","ref":"Litefs.html#backoff/1","title":"Litefs.backoff/1","type":"function"},{"doc":"","ref":"Litefs.html#check_for_litefs_primary_file/0","title":"Litefs.check_for_litefs_primary_file/0","type":"function"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Litefs.html#child_spec/1","title":"Litefs.child_spec/1","type":"function"},{"doc":"","ref":"Litefs.html#get/1","title":"Litefs.get/1","type":"function"},{"doc":"","ref":"Litefs.html#get_primary!/0","title":"Litefs.get_primary!/0","type":"function"},{"doc":"","ref":"Litefs.html#get_transaction_id/0","title":"Litefs.get_transaction_id/0","type":"function"},{"doc":"Callback implementation for GenServer.handle_continue/2 .","ref":"Litefs.html#handle_continue/2","title":"Litefs.handle_continue/2","type":"function"},{"doc":"Callback implementation for GenServer.init/1 .","ref":"Litefs.html#init/1","title":"Litefs.init/1","type":"function"},{"doc":"","ref":"Litefs.html#is_primary?/0","title":"Litefs.is_primary?/0","type":"function"},{"doc":"Executes the function on the remote node and waits for the response. iex&gt; Litefs.rpc(:primary, Litefs, :get_transaction_id, []) Exits after timeout milliseconds.","ref":"Litefs.html#rpc/5","title":"Litefs.rpc/5","type":"function"},{"doc":"","ref":"Litefs.html#rpc_and_wait/5","title":"Litefs.rpc_and_wait/5","type":"function"},{"doc":"","ref":"Litefs.html#set/2","title":"Litefs.set/2","type":"function"},{"doc":"","ref":"Litefs.html#start_link/1","title":"Litefs.start_link/1","type":"function"},{"doc":"","ref":"Litefs.html#update_primary/0","title":"Litefs.update_primary/0","type":"function"},{"doc":"","ref":"Litefs.html#wait_for_next_transaction_id/4","title":"Litefs.wait_for_next_transaction_id/4","type":"function"},{"doc":"This wraps the built-in Ecto.Repo functions to proxy writable functions like insert, update and delete to be performed on the an Elixir node in the primary region. To use it, rename your existing repo module and add a new module with the same name as your original repo like this. Original code: defmodule MyApp.Repo do use Ecto.Repo , otp_app : :my_app , adapter : Ecto.Adapters.Postgres end Changes to: defmodule MyApp.Repo.Local do use Ecto.Repo , otp_app : :my_app , adapter : Ecto.Adapters.SQLite3 end defmodule MyApp.Repo do use Litefs.Repo , local_repo : MyApp.Repo.Local end Using the same name allows your existing code to seamlessly work with the new repo. When explicitly managing database transactions like using Multi or start_transaction , when used to modify data, those functions should be called by an RPC so they run in the primary region. Litefs . rpc ( :primary , MyModule , :my_function_that_uses_multi , [ my , args ] , opts )","ref":"Litefs.Repo.html","title":"Litefs.Repo","type":"module"},{"doc":"When using Sqlite and Litefs with multiple servers, this forwards all write requests to the primary node. This library is based off of the packages fly_rpc and fly_postgres_elixir.","ref":"readme.html","title":"Elixir Litefs","type":"extras"},{"doc":"{ :litefs , git : &quot;https://git.sr.ht/~sheertj/elixir_litefs&quot; }","ref":"readme.html#installation","title":"Elixir Litefs - Installation","type":"extras"},{"doc":"To use it, rename your existing repo module and add a new module with the same name as your original repo like this. Original code: defmodule MyApp.Repo do use Ecto.Repo , otp_app : :my_app , adapter : Ecto.Adapters.SQLite3 end Changes to: defmodule MyApp.Repo.Local do use Ecto.Repo , otp_app : :my_app , adapter : Ecto.Adapters.SQLite3 end defmodule MyApp.Repo do use Litefs.Repo , local_repo : MyApp.Repo.Local end The Litefs.Repo performs all read operations like all , one , and get_by directly on the local replica. Other modifying functions like insert , update , and delete are performed on the primary database through proxy calls to a node in your Elixir cluster as identified by litefs . Migration Files After changing your repo name, generating migrations can end up in the wrong place, or at least not where you want them. You can override the inferred location in your config: config :my_app , MyApp.Repo.Local , priv : &quot;priv/repo&quot; Repo References The goal with using this repo wrapper, is to leave the majority of your application code and business logic unchanged. However, there are a few places that need to be updated to make it work smoothly. The following examples are places in your project code that need reference your actual Ecto.Repo . Following the above example, it should point to MyApp.Repo.Local . test_helper.exs files make references like this Ecto.Adapters.SQL.Sandbox.mode(MyApp.Repo.Local, :manual) data_case.exs files start the repo using Ecto.Adapters.SQL.Sandbox.start_owner! calls. channel_case.exs need to start your local repo. conn_case.exs need to start your local repo. config/config.exs needs to identify your local repo module. Ex: ecto_repos: [MyApp.Repo.Local] config/dev.exs , config/test.exs , config/runtime.exs - any special repo configuration should refer to your local repo. With these project plumbing changes, you application code can stay largely untouched! Application There are several changes to your application supervision tree. start the litefs genserver start the renamed local ecto repo ensure that all the elixir nodes can communicate (using libcluster in the example) defmodule MyApp.Application do use Application def start ( _type , _args ) do # ... topologies = Application . get_env ( :libcluster , :topologies ) || [ ] children = [ # Start litefs genserver and pass the local repo configuration { Litefs , Application . get_env ( :my_app , MyApp.Repo.Local ) } , # Start the Ecto repository MyApp.Repo.Local , # setup libcluster { Cluster.Supervisor , [ topologies , [ name : MyApp.ClusterSupervisor ] ] } , #... ] # ... end end Configure the local sqlite repo. config :my_app , MyApp.Repo.Local , database : &quot;/mnt/litefs1/test.db&quot; , journal_mode : :delete , pool_size : 5 , stacktrace : true Libcluster needs to be configured appropriately for dev.exs / runtime.exs. config :libcluster , topologies : [ local_epmd_example : [ strategy : Elixir.Cluster.Strategy.LocalEpmd ] ]","ref":"readme.html#configuration","title":"Elixir Litefs - Configuration","type":"extras"}]